C ESA (C) 2000-2018 
C
C This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
C
C    SAS is free software: you can redistribute it and/or modify
C    it under the terms of the GNU General Public License as published by
C    the Free Software Foundation, either version 3 of the License, or
C    (at your option) any later version.
C
C    SAS is distributed in the hope that it will be useful,
C    but WITHOUT ANY WARRANTY; without even the implied warranty of
C    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C    GNU General Public License for more details.
C
C    You should have received a copy of the GNU General Public License
C    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
      SUBROUTINE DJ2000(DAY,I,J,K,JHR,MI,SEC)
CP  COMPUTES CALENDER DATE FROM MODIFIED JULIAN DAY 2000
C   VALID FOR DATES BETWEEN 1950/JAN/1 AND 2099/DEC/31.
C   MJD(2000) = MJD(1950) - 18262.0 IS = 0 ON 2000/01/01 AT 00:00:00.
C
CI  (REAL*8) DAY = MOD. JULIAN DAY, REFERRED TO 2000 (MAY BE NEGATIVE).
CO  (INTEGERS): I=YEAR, J=MONTH, K=DAY, JHR=HOUR, MI=MINUTE
CO  (REAL*8): SEC=SECOND.
C
C
      IMPLICIT REAL*8(A-H,O-Z)
C  MAKE SURE TO ROUND-OFF ONLY DOWN, ALSO FOR NEGATIVE MJD:
      JDAY = DAY + 18262.D0
      L = (4000*(JDAY + 18204))/1461001
      N = JDAY - (1461*L)/4 + 18234
      M = (80*N)/2447
      K = N - (2447*M)/80
      JJ = M/11
      J = M + 2 - 12*JJ
      I = 1900 + L + JJ
      SEC = (DAY - DFLOAT(JDAY-18262))*24.D0
      JHR = SEC
      SEC = (SEC - DFLOAT(JHR))*6.D1
      MI = SEC
      SEC = (SEC - DFLOAT(MI))*6.D1
      RETURN
      END
