C ESA (C) 2000-2018 
C
C This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
C
C    SAS is free software: you can redistribute it and/or modify
C    it under the terms of the GNU General Public License as published by
C    the Free Software Foundation, either version 3 of the License, or
C    (at your option) any later version.
C
C    SAS is distributed in the hope that it will be useful,
C    but WITHOUT ANY WARRANTY; without even the implied warranty of
C    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C    GNU General Public License for more details.
C
C    You should have received a copy of the GNU General Public License
C    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
      SUBROUTINE GEOLAT(X,XLONG,XLAT,HEIGHT)
C
C  THIS VERSION OF "GEOLAT" IS DEDICATED TO THE  XMM PROJECT.
C  THE PARAMETERS "RE" AND "FLATSQ" ARE TAKEN FROM COOT20 AND WRITTEN
C  IN THIS SUBROUTINE AS DATA PARAMETERS.
C
CP CALCULATES GEODETIC LONG., LAT. AND HEIGHT FROM POSITION VECTOR.
C
CI  X(1),X(2),X(3) = POSITION VECTOR IN EARTH-FIXED SYSTEM
CO  XLONG = LONGITUDE (RAD)
CO  XLAT = LATITUDE (RAD)
CO  HEIGHT = HEIGHT ABOVE EARTH (KM)
C
C
      IMPLICIT NONE
      INTEGER K
      REAL*8 X(3),XLONG,XLAT,HEIGHT,XY,ZD,DO,SFQ,D,RE,FLATSQ
C
      DATA RE/6378.136/, FLATSQ/0.00669438499958795/
C
      XY = X(1)**2 + X(2)**2
      ZD = X(3)
      DO = 0.D0
C
      DO 1 K = 1,10
         ZD = ZD*ZD
         SFQ = ZD/(XY + ZD)
         D = RE*FLATSQ*DSQRT(SFQ/(1. D0 - FLATSQ*SFQ))
         ZD = X(3) + DSIGN(D,X(3))
C   ACCURACY = 1 CM
         IF (DABS(D-DO).LT.1.D-5) GOTO 3
         DO = D
 1       CONTINUE
 3    CONTINUE
C
      XLAT  = DATAN2(ZD,DSQRT(XY))
      HEIGHT= DSQRT(XY + ZD*ZD) - RE/DSQRT(1.D0 - FLATSQ*SFQ)
      XLONG = DATAN2(X(2),X(1))
C
      RETURN
      END
