C ESA (C) 2000-2018 
C
C This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
C
C    SAS is free software: you can redistribute it and/or modify
C    it under the terms of the GNU General Public License as published by
C    the Free Software Foundation, either version 3 of the License, or
C    (at your option) any later version.
C
C    SAS is distributed in the hope that it will be useful,
C    but WITHOUT ANY WARRANTY; without even the implied warranty of
C    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C    GNU General Public License for more details.
C
C    You should have received a copy of the GNU General Public License
C    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
      SUBROUTINE JD2000(DAY,JEAR,MONTH,KDAY,JHR,MI,SEC)
CP GIVES THE NEW MOD. JULIAN DAY (MJD=0.0 ON 2000/JAN/1 AT 0:00:00)
CP FOR INPUT CALENDAR DATES BETWEEN 1950/JAN/1 AND 2099/DEC/31.
C
C   MJD(2000) = MJD(1950) - 18262.0
C
CI  (INT*4) JEAR = YEAR WITH 2 OR 4 DIGITS; 2 DIGITS => 1950 TO 2049
CI  (INT*4) MONTH = MONTH
CI  (INT*4) KDAY = DAY
CI  (INT*4) JHR = HOUR
CI  (INT*4) MI = MINUTE
CI  (REAL*8) SEC = SECOND.
CO  (REAL*8) DAY = MOD. JUL. DAY, REFERRED TO 2000.
C
C
      IMPLICIT REAL*8(A-H,O-Z)
      JJ = (14 - MONTH)/12
      L = JEAR - JJ - 1900*(JEAR/1900) + 100*(2000/(JEAR+1951))
      DAY = KDAY-36496+(1461*L)/4+(367*(MONTH-2+JJ*12))/12
      DAY = DAY + (DFLOAT((JHR*60 + MI)*60) + SEC)/864.D2
      RETURN
      END
